v22.6.1
- Fix episode part parsing

v22.5.1
- Add support to inputstream.adaptive.common_headers to set headers
- Fix an issue that was replacing user headers set with inputstream.adaptive.common_headers

v22.5.0
- Add support for web stream extraction from HTML content
- Add support for custom regex patterns for web stream extraction

v22.4.2
- Translations updates from Weblate
	- af_za, am_et, ar_sa, ast_es, az_az, be_by, bg_bg, bs_ba, ca_es, cs_cz, cy_gb, da_dk, de_de, el_gr, en_au, en_nz, en_us, eo, es_ar, es_es, es_mx, et_ee, eu_es, fa_af, fa_ir, fi_fi, fo_fo, fr_ca, fr_fr, gl_es, he_il, hi_in, hr_hr, hu_hu, hy_am, id_id, is_is, it_it, ja_jp, ko_kr, lt_lt, lv_lv, mi, mk_mk, ml_in, mn_mn, ms_my, mt_mt, my_mm, nb_no, nl_nl, pl_pl, pt_br, pt_pt, ro_ro, ru_ru, si_lk, sk_sk, sl_si, sq_al, sr_rs, sr_rs@latin, sv_se, szl, ta_in, te_in, tg_tj, th_th, tr_tr, uk_ua, uz_uz, vi_vn, zh_cn, zh_tw

v22.4.1
- Release build

v22.4.0
- Set backend position for channel groups

v22.3.1
- Take account of whitespace at end of xmltv file while doing format check

v22.3.0
- PVR Add-on API v9.2.0

v22.2.2
- Fix XMLTV format check

v22.2.1
- Fix XML file format check
- Always treat special paths as local

v22.2.0
- Correctly set inputstream properties for media entries

v22.1.2
- Fix #KODIPROP parsing from playlists

v22.1.1
- Always add mimetype for inputstream.adaptive
- Better handled user-agent header for inputstream.adaptive use cases
- Fix missing manifest user-agent header for inputstream.adaptive
- Add missing SmoothStreaming mimetype for inputstream.adaptive

v22.1.0
- PVR Add-on API v9.0.0

v22.0.0
- Initial release for Piers (PVR Add-on API v8.4.0)

v21.8.4
- Translations updates from Weblate
	- af_za, am_et, ar_sa, ast_es, az_az, be_by, bg_bg, bs_ba, ca_es, cs_cz, cy_gb, da_dk, de_de, el_gr, en_au, en_nz, en_us, eo, es_ar, es_es, es_mx, et_ee, eu_es, fa_af, fa_ir, fi_fi, fo_fo, fr_ca, fr_fr, gl_es, he_il, hi_in, hr_hr, hu_hu, hy_am, id_id, is_is, it_it, ja_jp, ko_kr, lt_lt, lv_lv, mi, mk_mk, ml_in, mn_mn, ms_my, mt_mt, my_mm, nb_no, nl_nl, pl_pl, pt_br, pt_pt, ro_ro, ru_ru, si_lk, sk_sk, sl_si, sq_al, sr_rs, sr_rs@latin, sv_se, szl, ta_in, te_in, tg_tj, th_th, tr_tr, uk_ua, uz_uz, vi_vn, zh_cn, zh_tw

v21.8.3
- Change xz-utils to 5.4.3 to match kodi mirrors

v21.8.2
- Remove xz-utils windows depends since Findlzma.cmake was fixed
- Findlzma add alternate name to satisfy windows builds

v21.8.1
- Update zlib to v1.2.13
- Update pugixml to v1.14
- Update xz-utils to 5.4.3

v21.8.0
- Support catchup-id for live URLs where possible
- Support the Y, m, d, H, M, S specifiers for live URLs, useful for plugins and debugging
- Enable Play from EPG in Live TV mode setting for Catchup VOD
- Only set connection-timeout for connection manager if it's not NFS
- Support the duration specifier for live URLs, useful for plugins and debugging
- Support the all specifier for live URLs, useful for plugins and debugging
- Fix timezone shift not applied for start time for live URLs

v21.7.2
- Only reset the catchup state if not playing a timeshifted EPG tag

v21.7.1
- Fix supporting of local paths in Connection Manager

v21.7.0
- Add connection manager support to wait for a valid M3U file before starting the add-on instance
- The minimum refresh interval for the M3U should be 1 minutes and not zero, as that would be infinite refresh

v21.6.0
- Only reset channel group list when a channel URL is read from M3U Playlist
- Modify EXTGRP behaviour so it is a begin directive for channels groups, i.e. it carries across channels unless reset by an empty EXTGRP directive or any group-title tag for a EXTINF channel directive
- Update README with how EPG for Media works.

v21.5.0
- Extract season from medis title for path if not available
- Set default to inlcude media Group name in path if no dir present

v21.4.2
- Add support for Genres for Media

v21.4.1
- EPG entry selection criteria for timezone shift calculation works for Media as well as channels
- Fix being able to disable media from settings
- Fix group name in recording path being disabled in addon settings when media is not enabled

v21.4.0
- M3U format specifier to override realtime processing in Kodi PVR where the stream should not be treated like VOD/Media in the UI
- Revert the support of Async connect that was causing Connection Lost error messages for users of this add-on

v21.3.1
- Remove empty media groups before sending to Kodi PVR

v21.3.0
- Add settings options to add M3U group name to directory for media
- Add expert option to force the entire playlist to be Media. Useful now that multiple instances are supported
- Support custom groups for Media

v21.2.1
- Don't URL encode paths using resource:// or special:// protocols

v21.2.0
- Support async connect

v21.1.1
- Set default settings correctly and update settings migration

v21.1.0
- Add support for multiple instances each supporting their own M3U/XMLTV and settings

v20.7.0
- Add setting to make matching channel IDs and tvg-id's case sensitive

v20.6.1
- Ensure groups are delimited by semi-colon's when suoplied by an EXTGRP tag
- Don't break if multiple TVG URLs are supplied, just use the first one
- Fix warning from using sprintf by switching to snprintf

v20.6.0
- Kodi inputstream API update to version 3.2.0
- Kodi PVR API update to version 8.0.2

v20.5.2
- Fixed: Some icons using url arguments not displaying

v20.5.1
- Support url arguments when encoding file portion of icon URL

v20.5.0
- URL encode last part of tvg logo URL as they can be based on channel names and they can contain spaces and non standard characters not allowed in paths

v20.4.0
- Support ${duration} format specifier
- Fix azure image to use Windows 2019 and VS 2019

v20.3.1
- Fix ch-number tag being ignored

v20.3.0
- Choose a suitable default stream type for default and append catchup modes
- Allow catchup tags in M3U header
- Update flussonic catchup type strings
- For flussonic catchup add support for generic stream types (where any dir name is used after channel id)
- Support alternative tag name for channel number
- Fix incorrect provider mappings file path

v20.2.1
- Remove redundant PVR from addon name

v20.2.0
- Translation updates by Weblate
- Kodi main API update to version 2.0.0

v20.1.2
- Set default player as VideoPlayer for ffmpegdirect so Timeshift works for PVR Radio

v20.1.1
- Allow VOD or media tags to be used to specify view as PVR Recordings
- Remove news as Kodi 20 will load changelog.txt as a fallback anyway

v20.1.0
- Fixed: Change reported backend name
- Added: Support pvr providers in Kodi 20
- Added: Support VOD Media as recordings

v20.0.0
- Changed: Test builds to 'Kodi 20 Nexus'
- Increased version to 20.0.0
  - With start of Kodi 20 Nexus, takes addon as major the same version number as Kodi.
    This done to know easier to which Kodi the addon works.

v7.6.13
- Fixed: Apply timezone for first aired date if after 1970

v7.6.12
- Fixed: Always compare to the raw start date and not the localised time to detect NEW programmes
- Fixed: Do not set year if this programme is a TV show

v7.6.11
- Fixed: EPG date entry only parsing year

v7.6.10
- Fixed: Fix episode number when there is no season
- Fixed: Return server error if channels or groups could not be loaded due to missing file so they are not cleared in Kodi
- Translations updates from Weblate
	- id_id, ko_kr, pl_pl

v7.6.9
- Translations updates from Weblate
  - pl_pl

v7.6.8
- Translations updates from Weblate
  - zh_cn

v7.6.7
- Translations updates from Weblate
  - id_id, lt_lt

v7.6.6
- Language update from Weblate

v7.6.5
- Fixed: Allow embedded commas in channel name in M3U

v7.6.4
- Fixed: Only use Local logo location if file is relative
- Fixed: Add string initialisation from macros as some linux fail to compile without it

v7.6.3
- Skipped

v7.6.2
- Fixed: Allow catchup correction (timezone shift) when live URLs have catchup placeholders
- Fixed: Always load EPG data if we prefer XMLTV logos or catchup is enabled

v7.6.1
- Fixed: Allow ignoring M3U logos when using local logo path

v7.6.0
- Added: Support url-tvg in M3U header in addition to x-tvg-url
- Added: Add support for XZ compression of XMLTV data
- Fixed: Allow flusonnic channel ids containing forward slashes
- Fixed: Disable other catchup settings if catched is not enabled
- Added: Add setting for catchup correction
- Added: Support xeev XC catchup prefixes

v7.5.1
- Fixed: Treat 'tvg-rec' catchup tag like the siptv 'timeshift' tag
- Fixed: Ensure channel's catchup window is used instead of value from settings

v7.5.0
- Added: Support sub channel numbers
- Added: Allow setting scope for channels using catchup mode setting to enable overriding

v7.4.3
- Fixed: Add support for format specifiers use for detecting terminating catchup and granularity
- Update: Make inputstream add-ons a required dependency

v7.4.2
- Fixed: Add missing initialisation of display name with underscores after fixing slow epg

v7.4.1
- Update: Readme - update description for Kodi 19 and add table of contents

v7.4.0
- Fixed: An xmltv channel cannot have an empty id field
- Fixed: Fix slow epg load due to display name checks when finding a channel
- Fixed: Only force load EPG data on startup if catchup is enabled
- Added: Support custom channel group filters
- Added: Reload settings before reloading playlist and EPG data

v7.3.0
- Update: PVR API 7.1.0
- Added: support past and future max epg days and always load EPG data on start

v7.2.0
- Added: Safe localtime and format strings for timestamps in catchup
- Added: Allow now/current time format specifiers in live stream URLs
- Added: Redact catchup source and url format string
- Added: Some providers use 'tvg-rec' instead of 'catchup-days'
- Added: Set min ffmpegdirect version to 1.19.0 so it supports timestamp format

v7.1.0
- Added: Set minimum inputstream ffmpegdirect, rtmp and adaptive versions to API stable version for Matrix
- Added: Redact URLs when logged
- Update: Replace square brackets with bold text in addon settings help text

v7.0.0
- Update: PVR API 7.0.2

v6.4.1
- Update: Remove p8 from debian control file

v6.4.0
- Added: Add options to support both UDP and all stream types when using timeshift feature
- Fixed: README spelling corrections
- Update: Use add-on supplied StringUtils and remove local version

v6.3.2
- Update: Remove p8-platforms and add local StringUtils for cpp17

v6.3.1
- Fixed: Append TV/Radio to group name if the same group name is used for both channel types

v6.3.0
- Update: Allow max catchup of 15 days
- Added: Support premiere and new tag from XMLTV

v6.2.4
- Fixed: Only allow timeshift on streams that are live

v6.2.3
- Fixed: Don't allow timeshift mode on catchup VOD stream

v6.2.2
- Fixed: Correctly pass realtime stream information to inputstream.ffmpegdirect addon

v6.2.1
- Fixed: Fix timeshift not working for catchup streams without timestamp

v6.2.0
- Added: Add advanced option to always enabled timeshift for supported streams using custom M3U properties

v6.1.0
- Added: Check inputstream is installed or enabled if a custom inputstream is provided in M3U

v6.0.1
- Update PVR API 7.0.1

v6.0.0
- Update PVR API 7.0.0
- Rework addon to support new API interface

v5.2.0
- Added: Enable timeshift feature from inputstream.ffmpegdirect
- Added: Support VOD catchup streams including those via plugin URLs
- Added: Access to ffmpegdirect settings and inputstream checks (C++ API)
- Fixed: Fix flussonic ts detected as wrong type
- Fixed: Use kodis built in inputstreams for plugin urls
- Fixed: Fix incorrect catchup granularity for flussonic stream

v5.1.0
- Added: Support catchup-type M3U property
- Added: Set MIME type and manifest on stream types if required
- Added: Support multiple occurrences of year, month and day in catchup format specifiers
- Update: Change docs to use inputstream instead of inputstreamclass

v5.0.0
- Update PVR API 6.5.1
- Update Global API 1.2.0

v4.14.2
- Check to make sure catchup streams support timeshifting before letting them do so
- Fix catchup streams for fs, xc and shift being passed URL with possible protocol options

v4.14.1
- Fixed: Send manifest type property to ffmpegdirect so it can recognise Smooth Streaming

v4.14.0
- Added: Stream Manager for runtime caching of stream/mime types for speeding up channel switches
- Added: Deprecate use of inputstream.ffmpegdirect.mime_type and use mimetype property instead
- Added: Support advanced setting to set a default inputstream and/or MIME type for channels without them
- Fixed: Fix full timeshift calc not being applied to catchup streams
- Added: Suppport catchup-correction value in M3U file for catchup streams geo mismatched to wrong time

v4.13.6
- Update: PVR API 6.5.0

v4.13.5
- Fixed: Fix plugin URLs for channels by disabling stream type URL tests
- Update: Update readme concerning terminating catchup streams

v4.13.4
- Fixed: Only allow timeshifting catchup from EPG if channel supports it

v4.13.3
- Update: PVR API 6.4.0
- Update: Minor cleanups

v4.13.2
- Fixed: Install all inputstream dependencies by default.
- Fixed: Debian control files for run-time dependencies.

v4.13.1
- Fixed: Install ffmpegdirect dependency by default.

v4.13.0
- Added: Add support for catchup stream granularity property for ffmpegdirect
- Fixed: Terminating catchup stream check missing use case

v4.12.0
- Added: Add support for terminating catchup streams property for ffmpegdirect
- Update: Convert kodiprop names inputstreamaddon and inputstreamclass to inputstream on load

v4.11.7
- Fixed: stream media headers not set when inputstream.adaptive is used for HLS streams

v4.11.6
- Fixed: Fix incorrect live URL selection and inputstream for standard (no timeshift) catchup streams
- Fixed: Correctly cache mime_type for streams

v4.11.5
- Fixed: Typo in date regex, caused failure to load EPG on some platforms

v4.11.4
- Fixed: EPG performance
- Update: PVR API 6.3.0
- Added: GPLv2+ badge on README
- Update: SPDX in copyright header for for GPLv2 or later

v4.11.3
- Add: GPL2 license file and show GPL2 on README.md
- Update: Add source url, forum url and license name to addon.xml
- Update: Copyright year to 2020 and use Kodi / kodi.tv
- Update: Debian build code
- Update: Some minor cleanups

v4.11.2
- Update: PVR API 6.2.0

v4.11.1
- Fixed: Also check for ffmpegdirect mime type when checking stream type
- Fixed: Pass mime type to ffmpegdirect if available
- Fixed: Inspecting stream type for catchup mode shift should default to TS

v4.11.0
- Added: Support new catchup providers, shift, xc and fs including TS stream support
- Added: Support for timestamp catchup format specifier
- Added: Optional catchup-id per programme from XMLTV
- Added: Add catchup M3U8 examples to README
- Fixed: Live catchup streams that don't support timeshift
- Fixed: Don't build test catchup url for non catchup streams
- Added: Support for offset catchup format specifier
- Update: Add p8-platform to addon depends instead of from kodi

v4.10.0
- Added: User-Agent support from advanced addon setting

v4.9.0
- Added: Catchup support (a.k.a Archive)
- Added: Missing check for HLS stream type
- Update: Readme
- Fixed: strings.po comments

v4.8.5
- Update: Transifix language files

v4.8.4
- Fixed: Disable caching when using refresh M3U/XMLTV modes
- Fixed: Also check channel mime type property when determinig stream type
- Fixed: Correct settings levels

v4.8.3
- Fixed: Channel and epg refresh infinite loop

v4.8.2
- Fixed: Initialise properties size and check max
- Fixed: Playing a channel will crash if file/URL does not exist
- Fixed: Support both input stream class and addon properties
- Fixed: Allow override of ffmpeg reconnect option
- Fixed: Fix header property spelling
- Update: Readme

v4.8.1
- Fixed: Local channels logo with .jpg extension not working

v4.8.0
- Added: Allow use of inputstream ffmpeg for m3u8 files missing correct extension
- Added: Support for x-tvg-url in playlist header for XMLTV data
- Added: Add EXTVLCOPT properties for headers
- Fixed: Fix RTP multicast stream prefix
- Added: Add support for Dash and Smooth streaming via inputstream.adaptive
- Added: Add option to use inputsream.adaptive for m3u8/hls streams
- Added: Support FFmpeg reconnect for http streams using inputstream ffmpeg
- Fixed: Limit allowed EXTVLCOPT properties to known set
- Fixed: Add extra stream properties as lower case only
- Fixed: Support inputstreamaddon for overriding inputstream
- Update: Readme

v4.7.1
- Update: Switch from rapixml to pugixml
- Fixed: tvg-id does not match a channel if no display-names in xmltv
- Fixed: Combine multiple XMLTV channels sharing same id

v4.7.0
- Fixed: Add channel logo extension for relative paths only
- Fixed: Logger fix ported from pvr.hts
- Update: update readme
- Added: Transform UDP/RTP multicast stream URLs to local udpxy URLs

v4.6.1
- Fixed: Fix channel logos getting default extension

v4.6.0
- Added: M3U auto refresh
- Update: update github links for Matrix
- Update: Remove dependency on p8-platform util, thread and mutex
- Added: Switch EPGTimeshift setting to hours instead of minutes

v4.5.2
- Speed up EPG loading

v4.5.1
- Fix compiler warnings

v4.5.0
- Fixed: Support full timeshift range of -12 to +14 hours
- Fixed: Some providers incorrectly use tvg-ID instead of tvg-id
- Fixed: Support multiple display-names and case insensitive tvg-id is always first, next tvg-name and then channel name find order
- Added: support episode-num for both xmltv_ns and onscreen systems in epg entry
- Added: Update readme for supported M3U and XMLTV formats and genres
- Added: support star rating in epg entry
- Added: support firstAired and year in epg entry
- Added: Update OSX build script
- Added: support multiple actor/director/writers elements in epg entry
- Added: URLEncode and append .png ext for remote logos built from channel name
- Added: Support for mapping by genre hex ID and added example files and settings
- Added: Timing for Playlist and EPG Load
- Added: Option to number channels by M3U order only
- Update: Debug logging
- Added: Channel group member order set to M3U order
- Fixed: Fix segfault for compressed EPG files
- Added: Add ordering for groups as per PVR API 6.1.0

v4.4.0
- Update: Recompile for 6.1.0 PVR Addon API compatibility

v4.3.0
- Added: Auto reload channels, groups and EPG on settings change
- Added: Support for #EXTGRP tag in M3U file
- Fixed: Channel with no groups inherit previous channels groups
- Added: update new file kodi headers to start with kodi/

v4.2.2
- Update build system version
- Change header include way
- Add AppVeyor for Windows related build tests

v4.2.1
- Fix nullptr initialisation

v4.2.0
- Add support for sub-title/actor/director/writer in XML

v4.1.0
- Support EXTVCOPT in m3u8
- Build helper script for OSX

v4.0.2
- Fix wrong EPG times due to DST on Windows

v4.0.1
- Remove channels loaded notification

v4.0.0
- Update to PVR addon API v6.0.0

v3.5.7
- Correctly show build version in Kodi

v3.5.6
- Updated language files from Transifex

v3.5.5
- Bump zlib to version 1.2.11

v3.5.4
- Remove bundled rapidxml

v3.5.2
- Add support for #EXT-X-PLAYLIST-TYPE in M3U

v3.5.1
- Updated to PVR addon API v5.10.1

v3.5.0
- Updated to PVR addon API v5.10.0

v3.4.3
- Updated to PVR addon API v5.9.0

v3.4.1
- Add support for KODIPROP in M3U (for inputstream.adaptive)

v3.4.0
- Updated to PVR addon API v5.8.0

v3.3.3
- Fixed multithreading issues

v3.3.0
- Updated to PVR addon API v5.7.0

v3.2.2
- Updated to PVR addon API v5.6.0

v3.2.1
- Added support for multiple groups per channel, separated by semicolon

v3.2.0
- Updated to PVR addon API v5.5.0

v3.1.1
- removed line length limitation when parsing M3U files

v3.1.0
- Updated to PVR addon API v5.3.0

v3.0.6
- Remove of never used addon interface function

v3.0.5
- Update Debian package control
- PVR addon callback way changes

v3.0.4
- Removed old no more needed version functions

v3.0.3
- set dependency versions automatic during build
- removed never used kodi to addon functions
- build system fixes

v3.0.2
- Fix: Change the line lenght to 4k

v3.0.0
- Initial Kodi v18 version

v2.4.4
- Fix: Handle time offset in EPG programme start and end times.

v2.4.3
- updated language files from Transifex

v2.4.2
- updated language files from Transifex

v2.4.1
- updated language files from Transifex

v2.4.0
- Cmake: rename find_package kodi to Kodi
- Attempt to parse playlists lacking EXTM3U marker

v2.3.1
- Fix includes

v2.3.0
- Updated to PVR addon API v5.2.0

v2.2.0
- Updated to PVR addon API v5.1.0

v2.1.1
- Fix: Don't ignore channels logo if base logo path setting is empty.
- Fix: Don't apply base logo path to channels logo if tvg-logo has a full NET path.

v2.1.0
- Updated to PVR addon API v5.0.0

v2.0.2
- updated language files from Transifex

v2.0.1
- Updated to PVR API v4.2.0

v2.0.0
- Initial Kodi Krypton version.

v1.12.9
- updated language files from Transifex

v1.12.8
- updated language files from Transifex

v1.12.7
- updated language files from Transifex

v1.12.6
- Updated to PVR API v4.1.0

v1.12.5
- Updated to PVR API v4.0.0

v1.12.4
- Updated to PVR API v3.0.0 (API 1.9.7 compatibility mode)

v1.12.3
- Updated to PVR API v2.1.0
- Automatically fill in platform and library name

v1.12.2
- Debian packaging: fix library install path
- Miscellaneous backend fixes

v1.12.1
- updated to API v2.0.0

v1.12.0
- updated to API v1.9.7

v1.11.3
- updated language files from Transifex

v1.11.2
- updated to use new libplatform-dev

v1.11.1
- fixed EPG loading.

v1.11.0
- updated to API v1.9.6
- new feature: channel logos from xmltv
- new feature: map xmltv genre to Kodi genre via genres.xml
- now possible to define full logo path in m3u if logos path is empty in setting
- a lot of code improvements.

v1.10.2
- updated to API v1.9.5

v1.10.1
- language files from Transifex
- minor changes to conform with C++11
- Updated to API v1.9.4

v1.9.12
- added getBackendHostname function

v1.9.10
- change library name to Kodi

v1.9.9
- fixed deadlock when activating the addon on some darwin (osx, ios) runtimes

v1.9.6
- updated to API v1.9.2

v1.9.3
- added setting to disable cache m3u/epg
- added support <icon src=""/> for programme in epg
- added possibility to specify logo path as URL
- changed tvg-logo should contains full logo filename (with extention)
- changed don't try download xmltv if it doesn't load after 3 attempt.

v1.9.2
- add timeshift buffer functions

v1.8.1
- fixed issue with BOM header in EPG XML
- fixed issue with update channels if they are changed in m3u
- added setting starting number of channels

v1.8.0
- Initial version
- Supports m3u as Live TV streams source and XMLTV as EPG source
- Supports Live TV, Radio channels and EPG
